#include "limits.h"


/*@ type intpair = IPCons(integer, integer); */
/*@ axiomatic intpair {
     logic integer ip_fst(intpair p);
     logic integer ip_snd(intpair p);
     axiom ip_fst_def: \forall integer x, y; ip_fst(IPCons(x,y)) == x;
     axiom ip_snd_def: \forall integer x,y; ip_snd(IPCons(x,y)) == y;
	}
*/
/*@ predicate lexico(intpair p1, intpair p2) =
  @ \let x1 = ip_fst(p1);
  @ \let y1 = ip_snd(p1);
  @ \let x2 = ip_fst(p2);
  @ \let y2 = ip_snd(p2);
  @ x1 < x2 && 0 <= x2 ||
  @ x1 == x2 && 0 <= y2 && y1 < y2;
*/


/*@ requires 0 < n <= INT_MAX;
  @ requires 0 < m <= INT_MAX;
  @ requires \valid(matrix + (0 .. n-1));
  @ requires \forall int j; 0 <= j <= n-1 ==> \valid(matrix[j]+ (0 .. m-1));
*/
int max_matrix(int** matrix, int n, int m);
